
var pref;

function onSettingsLoad( ) {    
    var a = 0;
    pref = getPreferences( );
    
    document.getElementById("fname").value         = window.arguments[0].inn.log_file;
    document.getElementById("error_check").checked = window.arguments[0].inn.display_errors;
    document.getElementById("max_warnings").value  = window.arguments[0].inn.max_warnings;
    document.getElementById("max_lines").value     = window.arguments[0].inn.max_lines;

    /** font family **/
    var fontEnumerator = getFontList( );
    
    for ( a = 0; a < fontEnumerator.length; a++ ) {
        var fontName    = fontEnumerator[a];
        var item        = document.getElementById("font_list").appendItem( fontName, fontName );
    }
    
    
    /** charset **/
    var tmp_char = window.arguments[0].inn.charset;
    var element = document.getElementById("charset_menulist");
    for( a = 0; a < element.firstChild.childNodes.length; a++) {
        if(tmp_char == element.firstChild.childNodes[a].value) {
            element.selectedIndex = a;
            break;
        }
    }

    /** styles **/
    style_array = [];
    stylesEnumerator = pref.getChildList(_styles_root, style_array);
    for(var a = 0; a < stylesEnumerator.length; a++) {
        var style_name = stylesEnumerator[a].substring( _styles_root.length );
        var style = getCharPref(pref, _styles_root + style_name, "");
        var item  = document.getElementById("style-list-box").appendItem( style_name, null );
        var style_value = parseStyle( style );
        updateStyleListItem( item, style_value, style_name );
    }
    
    var ffid = setTimeout("selectUsedFontFamily( )", 500 );
}

/**
 * get the current defined font family and
 * select it into the font-family listbox
 */
function selectUsedFontFamily( ) {
    log( 'selectUsedFontFamily' );
    var fname = window.arguments[0].inn.font_family;
    var fsize = window.arguments[0].inn.font_size;
    
    // auto select the font-family
    var nodes = document.getElementById("font_list_menu").childNodes;
    for( var a = 0; a < nodes.length; a++ ) {
        if( nodes[a].value == fname ) {
            document.getElementById('font_list').selectedIndex = a;
            break;
        }
    }

    // auto select the font-size
    nodes = document.getElementById("fontsize_menupopup").childNodes;
    for(var a = 0; a < nodes.length; a++) {
        if( fsize == nodes[a].label) {
	    document.getElementById("fontsize_menulist").selectedIndex = a;
            break;
	}
    }
}

function onSettingsAccept() {
    var max_warnings = document.getElementById("max_warnings").value;
    var max_lines    = document.getElementById("max_lines").value;
    
    if(max_warnings == "" || max_warnings == null) {
        max_warnings = 0;
    }
    if(Number(max_warnings) == NaN) {
        max_warnings = 0;
    }
    
    if(max_lines == "" || max_lines == null) {
        max_lines = 0;
    }
    if(Number(max_lines) == NaN) {
        max_lines = 0;
    }
    
    max_warnings = Math.round(max_warnings);
    max_lines    = Math.round(max_lines);
    
    window.arguments[0].out = {
        log_file       : document.getElementById("fname").value,
        max_warnings   : max_warnings,
        max_lines      : max_lines,
        display_errors : document.getElementById("error_check").checked,
        charset        : document.getElementById("charset_menulist").selectedItem.value,
        font_family    : document.getElementById("font_list").selectedItem.value,
        font_size      : document.getElementById("fontsize_menulist").selectedItem.label
    };
}

function onSettingsHelp()
{
	window.openDialog(helpURL, "", "chrome,close");
}


function getFontList( ) {
    log("getFontList");
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    try { 
        //var fontListObj = Components.classes["@mozilla.org/gfx/fontlist;1"].createInstance( );
        var fontListObj = Components.classes["@mozilla.org/gfx/fontenumerator;1"].createInstance( Components.interfaces.nsIFontEnumerator );
        return fontListObj.EnumerateAllFonts({});
        //fontListObj = fontListObj.QueryInterface( Components.interfaces.nsIFontList );
        //return fontListObj.availableFonts( "","monospace" );	// enumerator
    } catch( error ){
        log( error );
    }
    return null;
}


/**
 * User click on the "browse..." button
 * then chose a user defined output file
 */
function choose_file()
{
    if( os =='mac')
    {
        alert("mac users, please enter the path to your desired output file manually in the file input field. Use the ':' as separator and remember to insert also the Volume name in the file path.\ne.g 'Macintosh HD:Users:username:Library:Preferences:Macromedia:Flash Player:Logs:flashlog.txt'");
        return false;
    }
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	fp.init(window, "Browse...", Components.interfaces.nsIFilePicker.modeSave);
	fp.appendFilters(Components.interfaces.nsIFilePicker.filterText);
	var rv = fp.show();
	var old_log = document.getElementById("fname").value;
	if (rv == Components.interfaces.nsIFilePicker.returnOK || rv == Components.interfaces.nsIFilePicker.returnReplace)
	{
		var file = fp.file;
		file.initWithPath(file.path);
		var created = true;
		try
		{
			var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
			foStream.init(file, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate ( 0444 )
			foStream.write("", 0);
			foStream.close();
		} catch(error)
		{
			created = false;
		}
		if(created)
		{
			document.getElementById("fname").value = file.path;
			log_file = file.path;
		} else {
			alert('Permission denied to read/write the specified file: ' + error);
			return false;
		}
	}
	return true;
}


// -------------------------
// styles
// -------------------------


// click on the 'New Style' button
function onNewStyle()
{
    var params = {inn:{label:"Untitled"}, out:null};
    var dlg = window.openDialog(newStyleURL, "dlg", "chrome,modal,close", params).focus();
    if( params.out )
    {
        addNewStyle( params.out.label );
    }
}


function addNewStyle( label )
{
	if( label.match(/[a-zA-Z][a-zA-Z0-9]+/) == null)
	{
		alert('Label must start with a letter and must contain at least 2 chars');
		return;
	}
	
	for( var a = 0; a < document.getElementById('style-list-box').getRowCount(); a++)
	{
		if( label == document.getElementById('style-list-box').getItemAtIndex(a).label)
		{
			alert("A style with the same name already exists, please change it!");
			return;
		}
	}
	
	var item  = document.getElementById("style-list-box").appendItem( label, null );
	var style_value = {};
	style_value['color'] = "#000000";
	style_value['font-style'] = 'normal';
	style_value['font-weight'] = 'normal';
	style_value['text-decoration'] = 'none';
	updateStyleListItem( item, style_value, label );
}


function onSaveStyle()
{
	if( document.getElementById('style-list-box').selectedIndex > -1 )
	{
		var item          = document.getElementById('style-list-box').selectedItem;
		var index         = document.getElementById('style-list-box').selectedIndex;
		var label         = document.getElementById('edit-style-label').value;
		var pattern       = document.getElementById('edit-style-pattern').value;
		
		try
		{
			"test".match(pattern);
		} catch(e)
		{
			alert("Invalid regular expression pattern: " + e);
			return;
		}
		
		if( label.match(/[a-zA-Z][a-zA-Z0-9]+/) == null)
		{
			alert('Label must start with a letter and must contain at least 2 chars');
			return;
		}
		
		for( var a = 0; a < document.getElementById('style-list-box').getRowCount(); a++)
		{
			if( a == index)
			{
				continue;
			}
			
			if( label == document.getElementById('style-list-box').getItemAtIndex(a).label)
			{
				alert("A style with the same name already exists, please change it!");
				return;
			}
		}
		
		var color         = document.getElementById('edit-style-color').color;
		var fontWeight    = document.getElementById('edit-style-weight').selectedItem.label;
		var fontStyle     = document.getElementById('edit-style-style').selectedItem.label;
		var textUnderline = document.getElementById('edit-style-underline').selectedItem.label;
		var content = "color:"+color+";font-weight:"+fontWeight+";font-style:"+fontStyle+";text-decoration:"+textUnderline;
		
		var content_obj = {};
		content_obj.color = color;
		content_obj['font-style'] = fontStyle;
		content_obj['font-weight'] = fontWeight;
		content_obj['text-decoration'] = textUnderline;
		
		setCharPref(pref, _styles_root + item.label, content);
		setCharPref(pref, _patterns_root + item.label, pattern);
		updateStyleListItem( item, content_obj, label );
	}
}

// listbox item selected
function onStyleSelected()
{
	var item = document.getElementById('style-list-box').selectedItem;
    if( item )
    {
        var value = parseStyle( getCharPref(pref, _styles_root + item.label, "" ) );
        document.getElementById('edit-style-label').value = item.label;
        document.getElementById('edit-style-pattern').value = getCharPref( pref, _patterns_root + item.label, "");
        document.getElementById('edit-style-color').color = value['color'];
        document.getElementById('edit-style-weight').selectedIndex = value['font-weight'] == 'bold' ? 1 : 0;
        document.getElementById('edit-style-style').selectedIndex = value['font-style'] == 'italic' ? 1 : 0;
        document.getElementById('edit-style-underline').selectedIndex = value['text-decoration'] == 'underline' ? 1 : 0;
        
        document.getElementById('b-style-enabled').setAttribute("disabled", false);
        document.getElementById('b-style-editable').setAttribute("editable", true);
    }
}

/**
 * Delete selected style rule style and pattern
 * 
 */
function onDeleteStyle()
{
    if( document.getElementById('style-list-box').selectedIndex > -1 )
    {
        var value = document.getElementById('style-list-box').selectedItem.label;    
        pref.deleteBranch( _styles_root + value );
        pref.deleteBranch( _patterns_root + value );    
        document.getElementById('style-list-box').removeItemAt(document.getElementById('style-list-box').selectedIndex);
        document.getElementById('b-style-enabled').setAttribute("disabled", true);
        document.getElementById('b-style-editable').setAttribute("editable", false);        
    }
}

/**
 * Parse a string css style into an object
 * @param   style String, the style string to be converted
 * @returns Object
 */
function parseStyle( style )
{
    var style_array = style.split(";");
    var item;
    var ret = {};
    ret['color'] = '#000000';
    ret['font-style'] = 'normal';
    ret['font-weight'] = 'normal';
    ret['text-decoration'] = 'none';
    
    for(var line in style_array)
    {
        try
        {
            item = trim(style_array[line]).split(":");
            ret[ trim(item[0]) ] = trim(item[1]);
        } catch(e){}
    }
    return ret;
}


/**
 * Update the listbox item containing the styles
 * @param item          the listbox item to be updated
 * @param style_value   Object, the style object
 * @param label         String, new item label
 */
function updateStyleListItem( item, style_value, label)
{
	item.label = label;
	item.style.color = style_value['color'];
	item.style.fontStyle = style_value['font-style'];
	item.style.fontWeight = style_value['font-weight'];
	item.style.textUnderline = style_value['text-decoration'];
}


